> ## Documentation Index
> Fetch the complete documentation index at: https://razorpay-60c89f9a-mintlify-audit-missing-sections-1778528421.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Android Standard SDK - Integration Steps

> Steps to integrate your Android application with Razorpay Android Standard SDK.

Follow these steps to integrate your Android application:

<CardGroup cols={3}>
  <Card title="1. Build Integration" icon="hammer" href="#1-build-integration" color="#3B82F6">
    Integrate Android Standard Checkout.
  </Card>

  <Card title="2. Test Integration" icon="flask-vial" href="#2-test-integration" color="#F59E0B">
    Test the integration by making a test payment.
  </Card>

  <Card title="3. Go-live Checklist" icon="rocket" href="#3-go-live-checklist" color="#10B981">
    Check the go-live checklist.
  </Card>
</CardGroup>

<br />

<iframe width="560" height="315" src="https://www.youtube.com/embed/MFQ3tz6P5Vw" title="How to Integrate Razorpay Payment Gateway on Android App" frameBorder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowFullScreen />

<Warning>
  **Watch Out!**

  The Android app must have a `minSDKversion` of 19 or higher. If you want to support devices below API level 19, you must override `minSDKversion`. Use the sample code below to override `minSDKversion`:

  ```xml theme={null}
  <uses-sdk android:targetSdkVersion="27" android:minSdkVersion="19"
              tools:overrideLibrary="com.razorpay"/>
  ```
</Warning>

## 1. Build Integration

Follow the steps given below:

<AccordionGroup>
  <Accordion title="1.1 Install Razorpay Android Standard SDK">
    To install the SDK in your Android project:

    Add the code given below to your project's top-level `build.gradle` file. This gives access to the SDK library.

    ```groovy build.gradle theme={null}
    repositories {
        mavenCentral()
    }

    dependencies {
        implementation 'com.razorpay:checkout:1.6.40'
    }
    ```

    <Info>
      **Handy Tips**

      From version 1.6.40 onwards, the latest version is automatically updated, eliminating the need for manual updates.
    </Info>
  </Accordion>

  <Accordion title="1.2 Initialize Razorpay Android Standard SDK">
    Add your `<API_KEY_ID>` dynamically using Checkout's `setKeyId()` method. You can generate the [API Keys](/payments/dashboard/account-settings/api-keys) from the Dashboard.

    To quickly load the `Checkout` form, the `preload` method of `Checkout` must be called much earlier than the other methods in the payment flow. The loading time of the preload resources can vary depending on your network's bandwidth.

    <CodeGroup>
      ```java Java theme={null}
      public class PaymentActivity extends Activity {

        // ...

        @Override
        public void onCreate(Bundle savedInstanceState) {
          super.onCreate(savedInstanceState);

          /**
           * Preload payment resources
           */
          Checkout.preload(getApplicationContext());

          // ...

          checkout.setKeyID("<YOUR_KEY_ID>");

          // ...
        }
      }
      ```

      ```kotlin Kotlin theme={null}
      class PaymentActivity: Activity(), PaymentResultWithDataListener, ExternalWalletListener {
          // .....
          override fun onCreate(savedInstanceState: Bundle?) {
              super.onCreate(savedInstanceState)
              setContentView(R.layout.activity_payment)
              /*
              * To ensure faster loading of the Checkout form,
              * call this method as early as possible in your checkout flow
              * */
              Checkout.preload(applicationContext)
              val co = Checkout()
              // apart from setting it in AndroidManifest.xml, keyId can also be set
              // programmatically during runtime
              co.setKeyID("rzp_live_XXXXXXXXXXXXXX")
          }
          //......
      }
      ```
    </CodeGroup>

    <Warning>
      **Watch Out!**

      It is recommended to send the API Key ID from your server-side as app-related metadata fetch. Do not add API Keys in the `AndroidManifest` file.
    </Warning>

    <Accordion title="Proguard Rules">
      If you are using Proguard for your builds, you must add the following lines to your `proguard-rules.pro` file.

      ```java theme={null}
      -keepclassmembers class * {
          @android.webkit.JavascriptInterface <methods>;
      }

      -keepattributes JavascriptInterface
      -keepattributes *Annotation*

      -dontwarn com.razorpay.**
      -keep class com.razorpay.** {*;}

      -optimizations !method/inlining/*

      -keepclasseswithmembers class * {
        public void onPayment*(...);
      }
      ```
    </Accordion>

    <Accordion title="SDK Integration Check">
      Call `Checkout.sdkCheckIntegration(activity)` to check the health of integration. This will also let you know if the SDK version is outdated. This will only appear in debug mode and not in the release.
    </Accordion>
  </Accordion>

  <Accordion title="1.3 Create an Order in Server">
    Given below are the order states and the corresponding payment states:

    | Payment Stages | Order State | Payment State     | Description                                                                                                                                                                                                                                                            |
    | -------------- | ----------- | ----------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
    | Stage I        | created     | created           | The customer submits the payment information, which is sent to Razorpay. The payment is **not processed** at this stage.                                                                                                                                               |
    | Stage II       | attempted   | authorized/failed | An order moves from **created** to **attempted** state when payment is first attempted. It remains in this state until a payment associated with the order is captured.                                                                                                |
    | Stage III      | paid        | captured          | After the payment moves to the **captured** state, the order moves to the **paid** state. No more payment requests are allowed after an order moves to the **paid** state. The order continues to be in this state even if the payment for this order is **refunded**. |

    <Info>
      **Capture Payments Automatically**

      You can capture payments automatically with the one-time [Payment Capture setting configuration](/payments/payments/capture-settings) on the Dashboard.
    </Info>

    <Note>
      **Order is an important step in the payment process.**

      * An order should be created for every payment.
      * You can create an order using the Orders API. It is a server-side API call. Know how to [authenticate](/payments/dashboard/account-settings/api-keys) Orders API.
      * The `order_id` received in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.
    </Note>

    <Warning>
      **Watch Out!**

      Payments made without an `order_id` cannot be captured and will be automatically refunded. You must create an order before initiating payments to ensure proper payment processing.
    </Warning>

    Use the below endpoint to create an order in your (backend) server.

    **POST** `/orders`

    <CodeGroup>
      ```bash cURL theme={null}
      curl -X POST https://api.razorpay.com/v1/orders \
      -U [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
      -H 'content-type:application/json' \
      -d '{
          "amount": 50000,
          "currency": "INR",
          "receipt": "qwsaq1",
          "partial_payment": true,
          "first_payment_min_amount": 230
      }'
      ```

      ```java Java theme={null}
      RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

      JSONObject orderRequest = new JSONObject();
      orderRequest.put("amount", 50000); // amount in the smallest currency unit
      orderRequest.put("currency", "INR");
      orderRequest.put("receipt", "order_rcptid_11");

      Order order = razorpay.Orders.create(orderRequest);
      } catch (RazorpayException e) {
      // Handle Exception
      System.out.println(e.getMessage());
      }
      ```

      ```python Python theme={null}
      import razorpay
      client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

      DATA = {
          "amount": 50000,
          "currency": "INR",
          "receipt": "receipt#1",
          "notes": {
              "key1": "value3",
              "key2": "value2"
          }
      }
      client.order.create(data=DATA)
      ```

      ```php PHP theme={null}
      $api = new Api($key_id, $secret);

      $api->order->create(array('receipt' => '123', 'amount' => 50000, 'currency' => 'INR', 'notes'=> array('key1'=> 'value3','key2'=> 'value2')));
      ```

      ```csharp .NET theme={null}
      RazorpayClient client = new RazorpayClient(your_key_id, your_secret);

      Dictionary options = new Dictionary();
      options.Add("amount", 50000); // amount in the smallest currency unit
      options.add("receipt", "order_rcptid_11");
      options.add("currency", "INR");
      Order order = client.Order.Create(options);
      ```

      ```ruby Ruby theme={null}
      require "razorpay"
      Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

      options = amount: 50000, currency: 'INR', receipt: ''
      order = Razorpay::Order.create
      ```

      ```javascript Node.js theme={null}
      var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

      instance.orders.create({
      amount: 50000,
      currency: "INR",
      receipt: "receipt#1",
      notes: {
          key1: "value3",
          key2: "value2"
      }
      })
      ```

      ```go Go theme={null}
      import ( razorpay "github.com/razorpay/razorpay-go" )
      client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

      data := map[string]interface{}{
      "amount": 50000,
      "currency": "INR",
      "receipt": "some_receipt_id"
      }
      body, err := client.Order.Create(data)
      ```
    </CodeGroup>

    <Tabs>
      <Tab title="Success Response">
        ```json theme={null}
        {
            "id": "order_IluGWxBm9U8zJ8",
            "entity": "order",
            "amount": 50000,
            "amount_paid": 0,
            "amount_due": 50000,
            "currency": "INR",
            "receipt": "rcptid_11",
            "offer_id": null,
            "status": "created",
            "attempts": 0,
            "notes": [],
            "created_at": 1642662092
        }
        ```
      </Tab>

      <Tab title="Failure Response">
        ```json theme={null}
        {
          "error": {
              "code": "BAD_REQUEST_ERROR",
              "description": "Order amount less than minimum amount allowed",
              "source": "business",
              "step": "payment_initiation",
              "reason": "input_validation_failed",
              "metadata": {},
              "field": "amount"
          }
        }
        ```
      </Tab>
    </Tabs>

    An order id (referred as `order_id`) is generated on the successful creation of an order. You should store this order id in your system against the order.

    Know more about [Orders API](/api/orders).

    <Info>
      **Handy Tips**

      Under the **Authorization** section in Postman, select **Basic Auth** and add the Key Id and secret as the Username and Password, respectively.
    </Info>

    ### Request Parameters

    <ParamField body="amount" type="integer" required>
      The transaction amount, expressed in the currency subunit. For example, for an actual amount of ₹222.25, the value of this field should be `22225`.
    </ParamField>

    <ParamField body="currency" type="string" required>
      The currency in which the transaction should be made. See the [list of supported currencies](/payments/international-payments#supported-currencies). Length must be of 3 characters.
    </ParamField>

    <ParamField body="receipt" type="string">
      Your receipt id for this order should be passed here. Maximum length is 40 characters.
    </ParamField>

    <ParamField body="notes" type="object">
      Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty"`.
    </ParamField>

    <ParamField body="partial_payment" type="boolean">
      Indicates whether the customer can make a partial payment. Possible values:

      * `true`: The customer can make partial payments.
      * `false` (default): The customer cannot make partial payments.
    </ParamField>

    <ParamField body="first_payment_min_amount" type="integer">
      Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as `500000`. This parameter should be passed only if `partial_payment` is `true`.
    </ParamField>

    ### Response Parameters

    Descriptions for the response parameters are present in the [Orders Entity](/api/orders) parameters table.

    ### Error Response Parameters

    The error response parameters are available in the [API Reference Guide](/api/orders).
  </Accordion>

  <Accordion title="1.4 Initiate Payment and Display Checkout Form" defaultOpen>
    There are two ways to pass the checkout parameters. You can either use `PayloadHelper` or the `JSONObject` options. We recommend using `PayloadHelper` to ensure that the right data types are used for the parameter values.

    <Accordion title="PayloadHelper" defaultOpen>
      Create a `JSONObject` to send it to the SDK.

      <CodeGroup>
        ```java Java theme={null}
        PayloadHelper payloadHelper = new PayloadHelper("<currency>", 100, "order_XXXXXXXXX");
              payloadHelper.setName("<name>");
              payloadHelper.setDescription("Description");
              payloadHelper.setPrefillEmail("<email>");
              payloadHelper.setPrefillContact("<phone>");
              payloadHelper.setPrefillCardNum("<cardNumber>");
              payloadHelper.setPrefillCardCvv("111");
              payloadHelper.setPrefillCardExp("11/30");
              payloadHelper.setPrefillMethod("card");
              payloadHelper.setPrefillName("MerchantName");
              payloadHelper.setSendSmsHash(true);
              payloadHelper.setRetryMaxCount(4);
              payloadHelper.setRetryEnabled(true);
              payloadHelper.setColor("#000000");
              payloadHelper.setAllowRotation(true);
              payloadHelper.setRememberCustomer(true);
              payloadHelper.setTimeout(10);
              payloadHelper.setRedirect(true);
              payloadHelper.setRecurring("1");
              payloadHelper.setSubscriptionCardChange(true);
              payloadHelper.setCustomerId("cust_XXXXXXXXXX");
              payloadHelper.setCallbackUrl("https://accepts-posts.request");
              payloadHelper.setSubscriptionId("sub_XXXXXXXXXX");
              payloadHelper.setModalConfirmClose(true);
              payloadHelper.setBackDropColor("#ffffff");
              payloadHelper.setHideTopBar(true);
              payloadHelper.setNotes(new JSONObject("{\"remarks\":\"Discount to customer\"}"));
              payloadHelper.setReadOnlyEmail(true);
              payloadHelper.setReadOnlyContact(true);
              payloadHelper.setReadOnlyName(true);
              payloadHelper.setImage("https://www.razorpay.com");
              payloadHelper.setAmount(100);
              payloadHelper.setCurrency("<currency>");
              payloadHelper.setOrderId("order_XXXXXXXXXXXXXX");
        ```

        ```kotlin Kotlin theme={null}
        val payloadHelper = PayloadHelper("<currency>", 100, "order_XXXXXXXXX")
                payloadHelper.name = "<name>"
                payloadHelper.description = "Description"
                payloadHelper.prefillEmail = "<email>"
                payloadHelper.prefillContact = "<phone>"
                payloadHelper.prefillCardNum = "<cardNumber>"
                payloadHelper.prefillCardCvv = "111"
                payloadHelper.prefillCardExp = "11/30"
                payloadHelper.prefillMethod = "card"
                payloadHelper.prefillName = "MerchantName"
                payloadHelper.sendSmsHash = true
                payloadHelper.retryMaxCount = 4
                payloadHelper.retryEnabled = true
                payloadHelper.color = "#000000"
                payloadHelper.allowRotation = true
                payloadHelper.rememberCustomer = true
                payloadHelper.timeout = 10
                payloadHelper.redirect = true
                payloadHelper.recurring = "1"
                payloadHelper.subscriptionCardChange = true
                payloadHelper.customerId = "cust_XXXXXXXXXX"
                payloadHelper.callbackUrl = "https://accepts-posts.request"
                payloadHelper.subscriptionId = "sub_XXXXXXXXXX"
                payloadHelper.modalConfirmClose = true
                payloadHelper.backDropColor = "#ffffff"
                payloadHelper.hideTopBar = true
                payloadHelper.notes = JSONObject("{\"remarks\":\"Discount to customer\"}")
                payloadHelper.readOnlyEmail = true
                payloadHelper.readOnlyContact = true
                payloadHelper.readOnlyName = true
                payloadHelper.image = "https://www.razorpay.com"
                // these values are set mandatorily during object initialization. Those values can be overridden like this
                payloadHelper.amount=100
                payloadHelper.currency="<currency>"
                payloadHelper.orderId = "order_XXXXXXXXXXXXXX"
        ```
      </CodeGroup>

      If you want to create certain options that are not available, add them to the `JSONObject` we get from `payloadHelper.getJson()`.
    </Accordion>

    <Accordion title="JSONObject" defaultOpen>
      You can alternatively use the JSONObject options given below.

      Create an instance of the `Checkout` and pass the payment details and options as a `JSONObject`. Ensure that you add the `order_id` generated in [Step 1.3](#13-create-an-order-in-server).

      <CodeGroup>
        ```java Java theme={null}
        public void startPayment() {
          checkout.setKeyID("<YOUR_KEY_ID>");
          /**
           * Instantiate Checkout
           */
          Checkout checkout = new Checkout();

          /**
           * Set your logo here
           */
          checkout.setImage(R.drawable.logo);

          /**
           * Reference to current activity
           */
          final Activity activity = this;

          /**
           * Pass your payment options to the Razorpay Checkout as a JSONObject
           */
          try {
              JSONObject options = new JSONObject();

              options.put("name", "Merchant Name");
              options.put("description", "Reference No. #123456");
              options.put("image", "http://example.com/image/rzp.jpg");
              options.put("order_id", "order_DBJOWzybf0sJbb");//from response of step 3.
              options.put("theme.color", "#3399cc");
              options.put("currency", "<currency>");
              options.put("amount", "50000");//pass amount in currency subunits
              options.put("prefill.email", "<email>");
              options.put("prefill.contact","<phone>");
              JSONObject retryObj = new JSONObject();
              retryObj.put("enabled", true);
              retryObj.put("max_count", 4);
              options.put("retry", retryObj);

              checkout.open(activity, options);

          } catch(Exception e) {
            Log.e(TAG, "Error in starting Razorpay Checkout", e);
          }
        }
        ```

        ```kotlin Kotlin theme={null}
        private fun startPayment() {
                /*
                *  You need to pass the current activity to let Razorpay create CheckoutActivity
                * */
                val activity:Activity = this
                val co = Checkout()

                try {
                    val options = JSONObject()
                    options.put("name","Razorpay Corp")
                    options.put("description","Demoing Charges")
                    //You can omit the image option to fetch the image from the Dashboard
                    options.put("image","http://example.com/image/rzp.jpg")
                    options.put("theme.color", "#3399cc");
                    options.put("currency","<currency>");
                    options.put("order_id", "order_DBJOWzybf0sJbb");
                    options.put("amount","50000")//pass amount in currency subunits

                    val retryObj = JSONObject();
                    retryObj.put("enabled", true);
                    retryObj.put("max_count", 4);
                    options.put("retry", retryObj);

                    val prefill = JSONObject()
                    prefill.put("email","<email>")
                    prefill.put("contact","<phone>")

                    options.put("prefill",prefill)
                    co.open(activity,options)
                }catch (e: Exception){
                    Toast.makeText(activity,"Error in payment: "+ e.message,Toast.LENGTH_LONG).show()
                    e.printStackTrace()
                }
            }
        ```
      </CodeGroup>
    </Accordion>

    <Info>
      **Handy Tips**

      When you paste the checkout options given above, the following error message appears: '`TAG` has private access in `androidx.fragment.app.FragmentActivity`'. You can resolve this by adding the following code:

      ```java theme={null}
      public class MainActivity extends AppCompatActivity implements PaymentResultListener {
      private static final String TAG = MainActivity.class.getSimpleName();
      ```
    </Info>

    `Checkout.open()` launches the Checkout form where the customer completes the payment and returns the payment result via appropriate callbacks on the `PaymentResultListener`.

    **Payment Options in JSONObject**:
    All available options in the `Standard Web Checkout` are also available in Android.

    <Accordion title="Checkout Options">
      You must pass these parameters in Checkout to initiate the payment.

      <ParamField body="key" type="string" required>
        API Key ID generated from the Dashboard.
      </ParamField>

      <ParamField body="amount" type="integer" required>
        Payment amount in the smallest currency subunit. For example, if the amount to be charged is ₹2222.50, enter `222250` in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
      </ParamField>

      <Warning>
        **Watch Out!**

        As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to charge a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as `99990` and not `99991`.
      </Warning>

      <ParamField body="currency" type="string" required>
        The currency in which the payment should be made by the customer. See the list of [supported currencies](/payments/international-payments#supported-currencies).
      </ParamField>

      <Info>
        **Handy Tips**

        Razorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about [Currency Conversion](/payments/international-payments/currency-conversion).
      </Info>

      <ParamField body="name" type="string" required>
        Your Business/Enterprise name shown on the Checkout form. For example, **Acme Corp**.
      </ParamField>

      <ParamField body="description" type="string">
        Description of the purchase item shown on the Checkout form. It should start with an alphanumeric character.
      </ParamField>

      <ParamField body="image" type="string">
        Link to an image (usually your business logo) shown on the Checkout form. Can also be a **base64** string if you are not loading the image from a network.
      </ParamField>

      <ParamField body="order_id" type="string" required>
        Order ID generated via [Orders API](/api/orders).
      </ParamField>

      <ParamField body="prefill" type="object">
        You can prefill the following details at Checkout.

        <Info>
          **Boost Conversions and Minimise Drop-offs**

          * Autofill customer contact details, especially phone number to ease form completion. Include customer's phone number in the `contact` parameter of the JSON request's `prefill` object. Format: +(country code)(phone number). Example: "contact": "+919000090000".
          * This is not applicable if you do not collect customer contact details on your website before checkout, have Shopify stores or use any of the no-code apps.
        </Info>

        * `name` (optional): Cardholder's name to be prefilled if customer is to make card payments on Checkout. For example, **Gaurav Kumar**.
        * `email` (optional): Email address of the customer.
        * `contact` (optional): Phone number of the customer. The expected format of the phone number is `+ {country code}{phone number}`. If the country code is not specified, `91` will be used as the default value. This is particularly important while prefilling `contact` of customers with phone numbers issued outside India. **Examples**: +14155552671 (a valid non-Indian number), +919977665544 (a valid Indian number). If 9977665544 is entered, `+91` is added to it as +919977665544.
        * `method` (optional): Pre-selection of the payment method for the customer. Will only work if `contact` and `email` are also prefilled. Possible values: `card`, `netbanking`, `wallet`, `upi`, `emi`.
      </ParamField>

      <ParamField body="notes" type="object">
        Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).
      </ParamField>

      <ParamField body="theme" type="object">
        Thematic options to modify the appearance of Checkout.

        * `color` (optional): Enter your brand colour's HEX code to alter the text, payment method icons and CTA (call-to-action) button colour of the Checkout form.
        * `backdrop_color` (optional): Enter a HEX code to change the Checkout's backdrop colour.
      </ParamField>

      <ParamField body="modal" type="object">
        Options to handle the Checkout modal.

        * `backdropclose` (optional): Indicates whether clicking the translucent blank space outside the Checkout form should close the form. Possible values: `true` (Closes the form when your customer clicks outside), `false` (default - Does not close the form).
        * `escape` (optional): Indicates whether pressing the **escape** key should close the Checkout form. Possible values: `true` (default - Closes the form), `false` (Does not close the form).
        * `handleback` (optional): Determines whether Checkout must behave similar to the browser when back button is pressed. Possible values: `true` (default - Checkout behaves similarly to the browser), `false` (Checkout does not simulate a back press).
        * `confirm_close` (optional): Determines whether a confirmation dialog box should be shown if customers attempts to close Checkout. Possible values: `true` (Confirmation dialog box is shown), `false` (default - No confirmation dialog).
        * `ondismiss` (optional): Used to track the status of Checkout. You can pass a modal object with `ondismiss: function(){}` as options. This function is called when the modal is closed by the user.
        * `animation` (optional): Shows an animation before loading of Checkout. Possible values: `true` (default - Animation appears), `false` (Animation does not appear).
      </ParamField>

      <ParamField body="subscription_id" type="string">
        If you are accepting recurring payments using Razorpay Checkout, you should pass the relevant `subscription_id` to the Checkout. Know more about [Subscriptions on Checkout](/api/payments/subscriptions).
      </ParamField>

      <ParamField body="subscription_card_change" type="boolean">
        Permit or restrict customer from changing the card linked to the subscription. Possible values: `true` (Allow the customer to change the card), `false` (default - Do not allow).
      </ParamField>

      <ParamField body="recurring" type="boolean">
        Determines if you are accepting recurring (charge-at-will) payments on Checkout via instruments such as emandate, paper NACH and so on. Possible values: `true` (Accepting recurring payments), `false` (default - Not accepting recurring payments).
      </ParamField>

      <ParamField body="callback_url" type="string">
        Customers will be redirected to this URL on successful payment. Ensure that the domain of the Callback URL is allowlisted.
      </ParamField>

      <ParamField body="redirect" type="boolean">
        Determines whether to post a response to the event handler post payment completion or redirect to Callback URL. `callback_url` must be passed while using this parameter. Possible values: `true` (Customer is redirected to the specified callback URL in case of payment failure), `false` (default - Customer is shown the Checkout popup to retry the payment).
      </ParamField>

      <ParamField body="customer_id" type="string">
        Unique identifier of customer. Used for:

        * [Local saved cards feature](/payments/payment-methods/cards/features/saved-cards).
        * Static bank account details on Checkout in case of [Bank Transfer payment method](/payments/payment-methods/bank-transfer).
      </ParamField>

      <ParamField body="remember_customer" type="boolean">
        Determines whether to allow saving of cards. Can also be configured via the [Dashboard](/payments/dashboard/account-settings/checkout-features). Possible values: `true` (Enables card saving feature), `false` (default - Disables card saving feature).
      </ParamField>

      <ParamField body="timeout" type="integer">
        Sets a timeout on Checkout, in seconds. After the specified time limit, the customer will not be able to use Checkout.
      </ParamField>

      <Warning>
        **Watch Out!**

        Some browsers may pause `JavaScript` timers when the user switches tabs, especially in power saver mode. This can cause the checkout session to stay active beyond the set timeout duration.
      </Warning>

      <ParamField body="readonly" type="object">
        Marks fields as read-only.

        * `contact` (optional): Used to set the `contact` field as readonly. Possible values: `true` (Customer will not be able to edit this field), `false` (default - Customer can edit).
        * `email` (optional): Used to set the `email` field as readonly. Possible values: `true` (Customer will not be able to edit this field), `false` (default - Customer can edit).
        * `name` (optional): Used to set the `name` field as readonly. Possible values: `true` (Customer will not be able to edit this field), `false` (default - Customer can edit).
      </ParamField>

      <ParamField body="hidden" type="object">
        Hides the contact details.

        * `contact` (optional): Used to set the `contact` field as optional. Possible values: `true` (Customer will not be able to view this field), `false` (default - Customer can view).
        * `email` (optional): Used to set the `email` field as optional. Possible values: `true` (Customer will not be able to view this field), `false` (default - Customer can view).
      </ParamField>

      <ParamField body="send_sms_hash" type="boolean">
        Used to auto-read OTP for cards and netbanking pages. Applicable from Android SDK version 1.5.9 and above. Possible values: `true` (OTP is auto-read), `false` (default - OTP is not auto-read).
      </ParamField>

      <ParamField body="allow_rotation" type="boolean">
        Used to rotate payment page as per screen orientation. Applicable from Android SDK version 1.6.4 and above. Possible values: `true` (Payment page can be rotated), `false` (default - Payment page cannot be rotated).
      </ParamField>

      <ParamField body="retry" type="object">
        Parameters that enable retry of payment on the checkout.

        * `enabled`: Determines whether the customers can retry payments on the checkout. Possible values: `true` (default - Enables customers to retry payments), `false` (Disables customers from retrying the payment).
        * `max_count`: The number of times the customer can retry the payment. We recommend you to set this to 4. Having a larger number here can cause loops to occur.
      </ParamField>

      <ParamField body="config" type="object">
        Parameters that enable checkout configuration. Know more about how to [configure payment methods on Razorpay standard checkout](/payments/payment-gateway/web-integration/standard/configure-payment-methods).

        * `display`: Child parameter that enables configuration of checkout display language.
          * `language`: The language in which checkout should be displayed. Possible values: `en` (English), `ben` (Bengali), `hi` (Hindi), `mar` (Marathi), `guj` (Gujarati), `tam` (Tamil), `tel` (Telugu).
      </ParamField>

      <Info>
        **Handy Tips**

        If you call the payment start method inside a fragment, ensure that the `fragment`'s parent `activity` implements the `PaymentResultListener` interface.
      </Info>
    </Accordion>
  </Accordion>

  <Accordion title="1.5 Handle Success and Error Events">
    You have the option to implement `PaymentResultListener` or `PaymentResultWithDataListener` to receive callbacks for the payment result.

    * `PaymentResultListener` provides only `payment_id` as the payment result.
    * `PaymentResultWithDataListener` provides additional payment data such as email and contact of the customer, along with the `order_id`, `payment_id`, `signature` and more.

    Use the code below to import the function in your `.java` file. This should be added at the beginning of the file.

    <CodeGroup>
      ```java PaymentResultListener theme={null}
      import com.razorpay.PaymentResultListener
      ```

      ```java PaymentResultWithDataListener theme={null}
      import com.razorpay.PaymentResultWithDataListener;
      ```
    </CodeGroup>

    <Accordion title="1.5.1 Sample Code">
      Given below are the sample codes for implementation:

      <Tabs>
        <Tab title="PaymentResultListener">
          <CodeGroup>
            ```java Java theme={null}
            public class PaymentActivity extends Activity implements PaymentResultListener {
              // ...

              @Override
              public void onPaymentSuccess(String razorpayPaymentID) {
                /**
                 * Add your logic here for a successful payment response
                 */
              }

              @Override
              public void onPaymentError(int code, String response) {
                /**
                 * Add your logic here for a failed payment response
                 */
              }
            }
            ```

            ```kotlin Kotlin theme={null}
            class PaymentActivity: Activity(), PaymentResultListener {
              // ...
                override fun onPaymentError(errorCode: Int, response: String?) {
                /**
                 * Add your logic here for a failed payment response
                 */
                }

                override fun onPaymentSuccess(razorpayPaymentId: String?) {
                /**
                 * Add your logic here for a successful payment response
                 */
                }
            }
            ```
          </CodeGroup>
        </Tab>

        <Tab title="PaymentResultWithDataListener">
          <CodeGroup>
            ```java Java theme={null}
            public class PaymentActivity extends Activity implements PaymentResultWithDataListener {
              // ...
              @Override
              public void onPaymentSuccess(String razorpayPaymentID, PaymentData paymentData) {
                /**
                 * Add your logic here for a successful payment response
                 */
              }
              @Override
              public void onPaymentError(int code, String response) {
                /**
                 * Add your logic here for a failed payment response
                 */
              }
            }
            ```

            ```kotlin Kotlin theme={null}
            class PaymentActivity: Activity(), PaymentResultWithDataListener {
              // ...
                override fun onPaymentError(errorCode: Int, response: String?) {
                /**
                 * Add your logic here for a failed payment response
                 */
                }
                override fun onPaymentSuccess(razorpayPaymentId: String?, PaymentData: PaymentData) {
                /**
                 * Add your logic here for a successful payment response
                 */
                }
            }
            ```
          </CodeGroup>
        </Tab>
      </Tabs>

      <Warning>
        **Watch Out!**

        * Razorpay's payment process takes place in a new activity. Since there are two activities involved, your activity can get corrupted or destroyed if the device is low on memory. These two methods should not depend on any variables not set through your life cycle hooks.
        * It is recommended that you test everything by enabling "Don't Keep Activities" in **Developer Options** under **Settings**.
      </Warning>
    </Accordion>

    <Accordion title="Error Codes">
      The error codes are returned in the `onPaymentError` method:

      | Error Code                  | Description                                                            |
      | --------------------------- | ---------------------------------------------------------------------- |
      | `Checkout.NETWORK_ERROR`    | There was a network error, for example, loss of internet connectivity. |
      | `Checkout.INVALID_OPTIONS`  | An issue with options passed in `checkout.open`.                       |
      | `Checkout.PAYMENT_CANCELED` | The user canceled the payment.                                         |
      | `Checkout.TLS_ERROR`        | The device does not support TLS v1.1 or TLS v1.2.                      |
    </Accordion>

    <Accordion title="1.5.2 Erase User Data from SDK">
      The SDK stores customer-specific data such as email, contact number, and user-session cookies if the customer wants to make another payment in the same session. You can delete such sensitive information before another customer logs into the app.

      To erase customer data from the app, you can call the following method anywhere in your app.

      ```java theme={null}
      Checkout.clearUserData(Context)
      ```
    </Accordion>
  </Accordion>

  <Accordion title="1.6 Store Fields in Your Server">
    A successful payment returns the following fields to the Checkout form.

    * You need to store these fields in your server.
    * You can confirm the authenticity of these details by verifying the signature in the next step.

    ```json theme={null}
    {
      "razorpay_payment_id": "pay_29QQoUBi66xm2f",
      "razorpay_order_id": "order_9A33XWu170gUtm",
      "razorpay_signature": "9ef4dffbfd84f1318f6739a3ce19f9d85851857ae648f114332d8401e0949a3d"
    }
    ```

    | Parameter             | Description                                                                              |
    | --------------------- | ---------------------------------------------------------------------------------------- |
    | `razorpay_payment_id` | Unique identifier for the payment returned by Checkout **only** for successful payments. |
    | `razorpay_order_id`   | Unique identifier for the order returned by Checkout.                                    |
    | `razorpay_signature`  | Signature returned by the Checkout. This is used to verify the payment.                  |
  </Accordion>

  <Accordion title="1.7 Verify Payment Signature">
    This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments.

    To verify the `razorpay_signature` returned to you by the Checkout form:

    1. Create a signature in your server using the following attributes:
       * `order_id`: Retrieve the `order_id` from your server. Do not use the `razorpay_order_id` returned by Checkout.
       * `razorpay_payment_id`: Returned by Checkout.
       * `key_secret`: Available in your server. The `key_secret` that was generated from the [Dashboard](/payments/dashboard/account-settings/api-keys).

    2. Use the SHA256 algorithm, the `razorpay_payment_id` and the `order_id` to construct a HMAC hex digest as shown below:

       ```
       generated_signature = hmac_sha256(order_id + "|" + razorpay_payment_id, secret);

       if (generated_signature == razorpay_signature) {
         payment is successful
       }
       ```

    3. If the signature you generate on your server matches the `razorpay_signature` returned to you by the Checkout form, the payment received is from an authentic source.

    ### Generate Signature on Your Server

    Given below is the sample code for payment signature verification:

    <CodeGroup>
      ```java Java theme={null}
      RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

      String secret = "EnLs21M47BllR3X8PSFtjtbd";

      JSONObject options = new JSONObject();
      options.put("razorpay_order_id", "order_IEIaMR65cu6nz3");
      options.put("razorpay_payment_id", "pay_IH4NVgf4Dreq1l");
      options.put("razorpay_signature", "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f");

      boolean status =  Utils.verifyPaymentSignature(options, secret);
      ```

      ```php PHP theme={null}
      $api = new Api($key_id, $secret);

      $api->utility->verifyPaymentSignature(array('razorpay_order_id' => $razorpayOrderId, 'razorpay_payment_id' => $razorpayPaymentId, 'razorpay_signature' => $razorpaySignature));
      ```

      ```ruby Ruby theme={null}
      require "razorpay"
      Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

      payment_response = {
            razorpay_order_id: 'order_IEIaMR65cu6nz3',
            razorpay_payment_id: 'pay_IH4NVgf4Dreq1l',
            razorpay_signature: '0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f'
          }
      Razorpay::Utility.verify_payment_signature(payment_response)
      ```

      ```python Python theme={null}
      import razorpay
      client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

      client.utility.verify_payment_signature({
        'razorpay_order_id': razorpay_order_id,
        'razorpay_payment_id': razorpay_payment_id,
        'razorpay_signature': razorpay_signature
        })
      ```

      ```csharp .NET theme={null}
      RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

      Dictionary options = new Dictionary();
      options.Add("razorpay_order_id", "order_IEIaMR65");
      options.Add("razorpay_payment_id", "pay_IH4NVgf4Dreq1l");
      options.Add("razorpay_signature", "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50");

      Utils.verifyPaymentSignature(options);
      ```

      ```javascript Node.js theme={null}
      var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

      var { validatePaymentVerification, validateWebhookSignature } = require('./dist/utils/razorpay-utils');
      validatePaymentVerification({"order_id": razorpayOrderId, "payment_id": razorpayPaymentId }, signature, secret);
      ```

      ```go Go theme={null}
      import ( razorpay "github.com/razorpay/razorpay-go" )
      client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

      params := map[string]interface{}{
      "razorpay_order_id": "order_IEIaMR65cu6nz3",
      "razorpay_payment_id": "pay_IH4NVgf4Dreq1l",
      }

      signature := "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f";
      secret := "EnLs21M47BllR3X8PSFtjtbd";
      utils.VerifyPaymentSignature(params, signature, secret)
      ```
    </CodeGroup>

    ### Post Signature Verification

    After you have completed the integration, you can [set up webhooks](/webhooks/setup-edit-payments), make test payments, replace the test key with the live key and integrate with other [APIs](/api).
  </Accordion>

  <Accordion title="1.8 Verify Payment Status">
    <Info>
      **Handy Tips**

      On the Razorpay Dashboard, ensure that the payment status is `captured`. Refer to the payment capture settings page to know how to [capture payments automatically](/payments/payments/capture-settings).
    </Info>

    You can track the payment status in three ways:

    <Tabs>
      <Tab title="From Dashboard">
        To verify the payment status from the Razorpay Dashboard:

        1. Log in to the Razorpay Dashboard and navigate to **Transactions** → **Payments**.
        2. Check if a **Payment Id** has been generated and note the status. In case of a successful payment, the status is marked as **Captured**.
      </Tab>

      <Tab title="Using Webhooks">
        You can use Razorpay webhooks to configure and receive notifications when a specific event occurs. When one of these events is triggered, we send an HTTP POST payload in JSON to the webhook's configured URL. Know how to [set up webhooks](/webhooks/setup-edit-payments).

        **Example**

        If you have subscribed to the `order.paid` webhook event, you will receive a notification every time a customer pays you for an order.
      </Tab>

      <Tab title="Poll APIs">
        [Poll Payment APIs](/api/payments) to check the payment status.
      </Tab>
    </Tabs>
  </Accordion>
</AccordionGroup>

## 2. Test Integration

After the integration is complete, a **Pay** button appears on your webpage/app.

Click the button and make a test transaction to ensure the integration is working as expected. You can start accepting actual payments from your customers once the test transaction is successful.

<Warning>
  **Watch Out!**

  This is a mock payment page that uses your test API keys, test card and payment details.

  * Ensure you have entered only your [Test Mode API keys](/payments/dashboard/account-settings/api-keys) in the Checkout code.
  * Test mode features a mock bank page with **Success** and **Failure** buttons to replicate the live payment experience.
  * No real money is deducted due to the usage of test API keys. This is a simulated transaction.
</Warning>

Following are all the payment modes that the customer can use to complete the payment on the Checkout. Some of them are available by default, while others may require approval from us. Raise a request from the Dashboard to enable such payment methods.

| Payment Method                                                                                                                                                                                      | Code            | Availability                                                       |
| --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------------- | ------------------------------------------------------------------ |
| [Debit Card](/payments/payment-methods/cards)                                                                                                                                                       | `debit`         | ✓                                                                  |
| [Credit Card](/payments/payment-methods/cards)                                                                                                                                                      | `credit`        | ✓                                                                  |
| [Netbanking](/payments/payment-methods/netbanking)                                                                                                                                                  | `netbanking`    | ✓                                                                  |
| [UPI](/payments/payment-methods/upi)                                                                                                                                                                | `upi`           | ✓                                                                  |
| EMI - [Credit Card EMI](/payments/payment-methods/emi/credit-card-emi), [Debit Card EMI](/payments/payment-methods/emi/debit-card-emi) and [No Cost EMI](/payments/payment-methods/emi/no-cost-emi) | `emi`           | ✓                                                                  |
| [Wallet](/payments/payment-methods/wallets)                                                                                                                                                         | `wallet`        | ✓                                                                  |
| [Cardless EMI](/payments/payment-methods/emi/cardless-emi)                                                                                                                                          | `cardless_emi`  | Requires [Approval](https://razorpay.com/support).                 |
| [Bank Transfer](/payments/payment-methods/bank-transfer)                                                                                                                                            | `bank_transfer` | Requires [Approval](https://razorpay.com/support) and Integration. |
| [Emandate](/payments/recurring-payments/emandate)                                                                                                                                                   | `emandate`      | Requires [Approval](https://razorpay.com/support) and Integration. |
| [Pay Later](/payments/payment-methods/pay-later)                                                                                                                                                    | `paylater`      | Requires [Approval](https://razorpay.com/support).                 |

You can make test payments using one of the payment methods configured at the Checkout.

<AccordionGroup>
  <Accordion title="Netbanking">
    You can select any of the listed banks. After choosing a bank, Razorpay will redirect to a mock page where you can make the payment `success` or a `failure`. Since this is Test Mode, we will not redirect you to the bank login portals.

    Check the list of [supported banks](/payments/payment-methods/netbanking#supported-banks).
  </Accordion>

  <Accordion title="UPI">
    You can enter one of the following UPI IDs:

    * `success@razorpay`: To make the payment successful.
    * `failure@razorpay`: To fail the payment.

    Check the list of [supported UPI flows](/payments/payment-methods/upi).

    <Info>
      **Handy Tips**

      You can use **Test Mode** to test UPI payments, and **Live Mode** for UPI Intent and QR payments.
    </Info>
  </Accordion>

  <Accordion title="Cards">
    You can use the following test cards to test transactions for your integration in Test Mode.

    ### Domestic Cards

    Use the following test cards for Indian payments:

    | Network    | Card Number         | CVV & Expiry Date                    |
    | ---------- | ------------------- | ------------------------------------ |
    | Visa       | 4100 2800 0000 1007 | Use a random CVV and any future date |
    | Mastercard | 5500 6700 0000 1002 | Use a random CVV and any future date |
    | RuPay      | 6527 6589 0000 1005 | Use a random CVV and any future date |
    | Diners     | 3608 280009 1007    | Use a random CVV and any future date |
    | Amex       | 3402 560004 01007   | Use a random CVV and any future date |

    #### Error Scenarios

    Use these test cards to simulate payment errors. See the [complete list](/payments/payments/test-card-details) of error test cards with detailed scenarios.

    Check the following lists:

    * [Supported Card Networks](/payments/payment-methods/cards).
    * [Cards Error Codes](/errors/payments/cards).

    ### International Cards

    Use the following test cards to test international payments. Use any valid expiration date in the future in the MM/YY format and any random CVV to create a successful payment.

    | Card Network | Card Number         | CVV & Expiry Date                    |
    | ------------ | ------------------- | ------------------------------------ |
    | Mastercard   | 5555 5555 5555 4444 | Use a random CVV and any future date |
    | Mastercard   | 5105 1051 0510 5100 | Use a random CVV and any future date |
    | Mastercard   | 5104 0600 0000 0008 | Use a random CVV and any future date |
    | Visa         | 4012 8888 8888 1881 | Use a random CVV and any future date |

    Check the list of [supported card networks](/payments/payment-methods/cards).
  </Accordion>

  <Accordion title="Wallet">
    You can select any of the listed wallets. After choosing a wallet, Razorpay will redirect to a mock page where you can make the payment `success` or a `failure`. Since this is Test Mode, we will not redirect you to the wallet login portals.

    Check the list of [supported wallets](/payments/payment-methods/wallets#supported-wallets).
  </Accordion>
</AccordionGroup>

## 3. Go-live Checklist

Check the go-live checklist for Razorpay Android Standard SDK. Consider these steps before taking the integration live.

<AccordionGroup>
  <Accordion title="3.1 Accept Live Payments">
    Perform an end-to-end simulation of funds flow in the Test Mode. Once confident that the integration is working as expected, switch to the Live Mode and start accepting payments from customers.

    <Warning>
      **Watch Out!**

      Ensure you are switching your test API keys with API keys generated in Live Mode.
    </Warning>

    To generate API Keys in Live Mode on your Razorpay Dashboard:

    1. Log in to the Razorpay Dashboard and switch to **Live Mode** on the menu.
    2. Navigate to **Account & Settings** → **API Keys** → **Generate Key** to generate the API Key for Live Mode.
    3. Download the keys and save them securely.
    4. Replace the Test API Key with the Live Key in the Checkout code and start accepting actual payments.
  </Accordion>

  <Accordion title="3.2 Payment Capture">
    After payment is `authorized`, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.

    <Warning>
      **Watch Out**

      * You should deliver the products or services to your customers only after the payment is captured. Razorpay automatically refunds all the uncaptured payments.
      * You can track the payment status using our [Fetch a Payment API](/api/payments) or webhooks.
    </Warning>

    <Tabs>
      <Tab title="Automatic Capture">
        Authorized payments can be automatically captured. You can auto-capture all payments [using global settings](/payments/payments/capture-settings) on the Razorpay Dashboard. Know more about [capture settings for payments](/payments/payments/capture-settings).

        <Warning>
          **Watch Out!**

          Payment capture settings work only if you have integrated with Orders API on your server side. Know more about the [Orders API](/api/orders).
        </Warning>
      </Tab>

      <Tab title="Manual Capture">
        Each authorized payment can also be captured individually. You can manually capture payments using [Payment Capture API](/api/payments) or [Dashboard](/payments/payments/dashboard). Know more about [capture settings for payments](/payments/payments/capture-settings).
      </Tab>
    </Tabs>
  </Accordion>

  <Accordion title="3.3 Set Up Webhooks">
    Ensure you have [set up webhooks](/webhooks/setup-edit-payments) in the live mode and configured the events for which you want to receive notifications.

    <Warning>
      **Implementation Considerations**

      Webhooks are the primary and most efficient method for event notifications. They are delivered asynchronously in near real-time. For critical user-facing flows that need instant confirmation (like showing "Payment Successful" immediately), supplement webhooks with API verification.

      **Recommended approach**

      * Rely on webhooks for all automation, which can be asynchronous.
      * If a critical user-facing flow requires instant status, but the webhook notification has not arrived within the time mandated by your business needs, perform an immediate API Fetch call ([Payments](/api/payments), [Orders](/api/orders) and [Refunds](/api/refunds)) to verify the status.
    </Warning>
  </Accordion>
</AccordionGroup>

### Related Information

[Google Play's Data Safety](/payments/payment-gateway/android-integration/standard/google-data-safety)
